var NAVTREE =
[
  [ "ViSP", "index.html", [
    [ "Online documentation for ViSP 2.9.0", "index.html", [
      [ "Introduction", "index.html#intro_sec", null ],
      [ "Download", "index.html#download_sec", null ],
      [ "Installation", "index.html#install_sec", null ],
      [ "Tutorials", "index.html#Tutorial_sec", [
        [ "Introduction", "index.html#tuto_intro", null ],
        [ "Image manipulation", "index.html#tuto_image", null ],
        [ "Camera calibration", "index.html#tuto_calib", null ],
        [ "Tracking", "index.html#tuto_tracking", null ],
        [ "Keypoint", "index.html#tuto_keypoint", null ],
        [ "Computer vision", "index.html#tuto_computer_vision", null ],
        [ "Visual servoing", "index.html#tuto_vs", null ],
        [ "Other tools", "index.html#tuto_tools", null ]
      ] ],
      [ "Using ViSP", "index.html#Examples_sec", null ],
      [ "How to help ?", "index.html#Howto_sec", null ]
    ] ],
    [ "Tutorial: How to boost your visual servo control law", "d8/d36/tutorial-boost-vs.html", [
      [ "Introduction", "d8/d36/tutorial-boost-vs.html#intro", null ],
      [ "Using an adaptive gain", "d8/d36/tutorial-boost-vs.html#adaptive_gain", null ],
      [ "Continuous sequencing", "d8/d36/tutorial-boost-vs.html#continuous_adaptive_gain", null ]
    ] ],
    [ "Tutorial: Camera calibration", "d4/d23/tutorial-calibration.html", [
      [ "Introduction", "d4/d23/tutorial-calibration.html#calibration_intro", null ],
      [ "Source code", "d4/d23/tutorial-calibration.html#calibration_source_code", null ],
      [ "Calibration from a chessboard", "d4/d23/tutorial-calibration.html#calibration_chessboard", null ],
      [ "Calibration from a circles grid", "d4/d23/tutorial-calibration.html#calibration_circle", null ],
      [ "Distorsion removal", "d4/d23/tutorial-calibration.html#calibration_undistort", null ]
    ] ],
    [ "Tutorial: Getting started for iOS", "d4/d77/tutorial-getting-started-iOS.html", [
      [ "Add ViSP library into your project", "d4/d77/tutorial-getting-started-iOS.html#getting-started-iOS-add", null ],
      [ "Copy ViSP header into your project", "d4/d77/tutorial-getting-started-iOS.html#getting-started-iOS-copy", null ],
      [ "Use ViSP in your project", "d4/d77/tutorial-getting-started-iOS.html#getting-started-iOS-use", null ]
    ] ],
    [ "Tutorial: Getting started", "de/d13/tutorial-getting-started.html", [
      [ "Create a program using ViSP", "de/d13/tutorial-getting-started.html#image_code", null ],
      [ "Create a CMake file", "de/d13/tutorial-getting-started.html#image_cmake", null ],
      [ "On Unix-like systems", "de/d13/tutorial-getting-started.html#image_unix", [
        [ "Configure your project", "de/d13/tutorial-getting-started.html#image_unix_config", null ],
        [ "Generate the executable", "de/d13/tutorial-getting-started.html#image_unix_build", null ],
        [ "Run the executable", "de/d13/tutorial-getting-started.html#image_unix_output", null ]
      ] ],
      [ "On Windows", "de/d13/tutorial-getting-started.html#image_win", [
        [ "Configure your project", "de/d13/tutorial-getting-started.html#image_win_config", null ],
        [ "Generate the executable", "de/d13/tutorial-getting-started.html#image_win_build", null ],
        [ "Run the executable", "de/d13/tutorial-getting-started.html#image_win_output", null ]
      ] ]
    ] ],
    [ "Tutorial: Image frame grabbing", "dc/d8f/tutorial-grabber.html", [
      [ "Images from firewire cameras", "dc/d8f/tutorial-grabber.html#grabber-camera-firewire-unix", null ],
      [ "Images from other cameras", "dc/d8f/tutorial-grabber.html#grabber-camera-other", null ],
      [ "Images from a video stream", "dc/d8f/tutorial-grabber.html#grabber-video-stream", null ]
    ] ],
    [ "Tutorial: Homography estimation from points", "d2/d63/tutorial-homography.html", [
      [ "Homography estimation", "d2/d63/tutorial-homography.html#homography", null ],
      [ "Ransac or robust homography estimation", "d2/d63/tutorial-homography.html#ransac", null ]
    ] ],
    [ "Tutorial: Image-based visual servo", "db/d8c/tutorial-ibvs.html", [
      [ "Introduction", "db/d8c/tutorial-ibvs.html#ibvs_intro", null ],
      [ "Basic IBVS simulation", "db/d8c/tutorial-ibvs.html#ibvs_basic", null ],
      [ "IBVS simulation with basic viewers", "db/d8c/tutorial-ibvs.html#ibvs_display", null ],
      [ "IBVS simulation with wireframe viewers", "db/d8c/tutorial-ibvs.html#ibvs_wireframe", null ],
      [ "IBVS simulation with image processing", "db/d8c/tutorial-ibvs.html#ibvs_tracking", null ]
    ] ],
    [ "Tutorial: Image filtering", "db/dd1/tutorial-image-filtering.html", [
      [ "Gaussian blur", "db/dd1/tutorial-image-filtering.html#blur", null ],
      [ "Gradients computation", "db/dd1/tutorial-image-filtering.html#gradient", null ],
      [ "Canny edge detector", "db/dd1/tutorial-image-filtering.html#canny", null ],
      [ "Convolution", "db/dd1/tutorial-image-filtering.html#convolution", null ],
      [ "Gaussian image pyramid", "db/dd1/tutorial-image-filtering.html#pyramid", null ]
    ] ],
    [ "Tutorial: Installation from source on Linux Fedora", "d7/d19/tutorial-install-fedora.html", [
      [ "Required packages", "d7/d19/tutorial-install-fedora.html#install_ubuntu_required", null ],
      [ "Getting ViSP source code", "d7/d19/tutorial-install-fedora.html#install_fedora_get_source", null ],
      [ "Configuring ViSP from source", "d7/d19/tutorial-install-fedora.html#install_fedora_config", [
        [ "Optional 3rd party packages", "d7/d19/tutorial-install-fedora.html#install_fedora_3rdparty", null ],
        [ "Generating Makefiles", "d7/d19/tutorial-install-fedora.html#install_ubuntu_generate", null ]
      ] ],
      [ "Building ViSP from source", "d7/d19/tutorial-install-fedora.html#install_fedora_build", null ]
    ] ],
    [ "Tutorial: Installation from source on OSX for iOS devices", "d8/d04/tutorial-install-iOS.html", [
      [ "Required software", "d8/d04/tutorial-install-iOS.html#install_iOS_required", null ],
      [ "Getting ViSP source code", "d8/d04/tutorial-install-iOS.html#install_iOS_get_source", null ],
      [ "Configuring ViSP from source", "d8/d04/tutorial-install-iOS.html#install_iOS_config", [
        [ "Optional 3rd party packages", "d8/d04/tutorial-install-iOS.html#install_iOS_3rdparty", null ],
        [ "Generate Xcode project", "d8/d04/tutorial-install-iOS.html#install_iOS_generate_xcode", null ]
      ] ],
      [ "Building ViSP library", "d8/d04/tutorial-install-iOS.html#install_iOS_build", [
        [ "Open and configure ViSP Xcode project", "d8/d04/tutorial-install-iOS.html#getting-started-iOS-configure", null ],
        [ "Generate ViSP library", "d8/d04/tutorial-install-iOS.html#getting-started-iOS-generate", null ]
      ] ]
    ] ],
    [ "Tutorial: Installation from source on Linux Ubuntu", "d1/d3f/tutorial-install-ubuntu.html", [
      [ "Getting ViSP source code", "d1/d3f/tutorial-install-ubuntu.html#install_ubuntu_get_source", null ],
      [ "Configuring ViSP from source", "d1/d3f/tutorial-install-ubuntu.html#install_ubuntu_config", [
        [ "Optional 3rd party packages", "d1/d3f/tutorial-install-ubuntu.html#install_ubuntu_3rdparty", null ]
      ] ],
      [ "Building ViSP from source", "d1/d3f/tutorial-install-ubuntu.html#install_ubuntu_build", null ]
    ] ],
    [ "Tutorial: Installation from source on Windows", "d5/d2a/tutorial-install-win.html", [
      [ "Required packages", "d5/d2a/tutorial-install-win.html#install_win_required", null ],
      [ "Getting ViSP source code", "d5/d2a/tutorial-install-win.html#install_win_get_source", null ],
      [ "Configuring ViSP from source", "d5/d2a/tutorial-install-win.html#install_win_config", [
        [ "Optional 3rd party packages", "d5/d2a/tutorial-install-win.html#install_win_3rdparty", [
          [ "OpenCV 3rd party", "d5/d2a/tutorial-install-win.html#install_win_3rdparty_opencv", null ],
          [ "Ogre3D 3rd party", "d5/d2a/tutorial-install-win.html#install_win_3rdparty_ogre", null ]
        ] ],
        [ "Ending the configuration", "d5/d2a/tutorial-install-win.html#install_win_gene", null ]
      ] ],
      [ "Building ViSP from source", "d5/d2a/tutorial-install-win.html#install_win_build", null ],
      [ "Setting up PATH variable", "d5/d2a/tutorial-install-win.html#install_win_env_var", null ],
      [ "Appendix", "d5/d2a/tutorial-install-win.html#install_win_annex", [
        [ "Installing testing data", "d5/d2a/tutorial-install-win.html#install_annex_data", null ],
        [ "Using testing data", "d5/d2a/tutorial-install-win.html#install_annex_usage", null ]
      ] ]
    ] ],
    [ "Tutorial: Keypoint matching", "da/d4a/tutorial-matching.html", [
      [ "SURF key points detection and matching", "da/d4a/tutorial-matching.html#surf", null ]
    ] ],
    [ "Tutorial: Real-time curves plotter tool", "d2/d43/tutorial-plotter.html", null ],
    [ "Tutorial: Pose estimation from points", "d1/d9d/tutorial-pose-estimation.html", [
      [ "Introduction", "d1/d9d/tutorial-pose-estimation.html#tutorial_pose_intro", null ],
      [ "Pose estimation from 4 planar points", "d1/d9d/tutorial-pose-estimation.html#tutorial_pose_est", null ]
    ] ],
    [ "Tutorial: Planar image projection", "de/df7/tutorial-simu-image.html", [
      [ "Introduction", "de/df7/tutorial-simu-image.html#simu_image_intro", null ],
      [ "Image projection", "de/df7/tutorial-simu-image.html#simu_image_projection", null ]
    ] ],
    [ "Tutorial: Visual servo simulation on a pioneer-like unicycle robot", "d5/dfa/tutorial-simu-robot-pioneer.html", [
      [ "Unicycle with a fixed camera", "d5/dfa/tutorial-simu-robot-pioneer.html#simu_robot_pioneer_camera", null ],
      [ "Unicycle with a moving camera", "d5/dfa/tutorial-simu-robot-pioneer.html#simu_robot_pioneer_camera_pan", null ]
    ] ],
    [ "Tutorial: Debug and trace printings", "d7/db3/tutorial-trace.html", [
      [ "Debug and trace usage in ViSP library", "d7/db3/tutorial-trace.html#visp", null ],
      [ "Debug and trace usage in your own project", "d7/db3/tutorial-trace.html#example", null ]
    ] ],
    [ "Tutorial: Blob tracking", "d9/d7d/tutorial-tracking-blob.html", [
      [ "Blob tracking", "d9/d7d/tutorial-tracking-blob.html#tracking_blob_tracking", null ],
      [ "Blob auto detection and tracking", "d9/d7d/tutorial-tracking-blob.html#tracking_blob_auto", null ]
    ] ],
    [ "Tutorial: Keypoint tracking", "d8/d59/tutorial-tracking-keypoint.html", [
      [ "KLT tracker", "d8/d59/tutorial-tracking-keypoint.html#tracking_keypoint_klt", null ]
    ] ],
    [ "Tutorial: Model-based tracking", "dd/dc7/tutorial-tracking-mb.html", [
      [ "Model-based edges tracker", "dd/dc7/tutorial-tracking-mb.html#tracking_mb_edges", null ],
      [ "Model-based KLT tracker", "dd/dc7/tutorial-tracking-mb.html#tracking_mb_klt", null ],
      [ "Model-based hybrid tracker", "dd/dc7/tutorial-tracking-mb.html#tracking_mb_hybrid", null ],
      [ "CAD model in cao format", "dd/dc7/tutorial-tracking-mb.html#tracking_mb_cao", [
        [ "Macros for trace", "d7/db3/tutorial-trace.html#trace", null ],
        [ "Macros for debug", "d7/db3/tutorial-trace.html#debug", null ],
        [ "teabox.cao example", "dd/dc7/tutorial-tracking-mb.html#tracking_mb_cao_face", null ],
        [ "teabox-triangle.cao example", "dd/dc7/tutorial-tracking-mb.html#tracking_mb_cao_triangle", null ]
      ] ],
      [ "CAD model in vrml format", "dd/dc7/tutorial-tracking-mb.html#tracking_mb_wrl", [
        [ "teabox.wrl example", "dd/dc7/tutorial-tracking-mb.html#tracking_mb_vrml_face", null ]
      ] ]
    ] ],
    [ "Tutorial: Moving-edges tracking", "de/d1e/tutorial-tracking-me.html", [
      [ "Line tracking", "de/d1e/tutorial-tracking-me.html#tracking_me_line", null ],
      [ "Ellipse tracking", "de/d1e/tutorial-tracking-me.html#tracking_me_ellipse", null ]
    ] ],
    [ "Tutorial: Template tracking", "d4/dfc/tutorial-tracking-tt.html", [
      [ "Track the painting", "d4/dfc/tutorial-tracking-tt.html#tracking_tt", [
        [ "Warping classes", "d4/dfc/tutorial-tracking-tt.html#warp_tt", null ],
        [ "How to tune the tracker", "d4/dfc/tutorial-tracking-tt.html#tune_tt", null ],
        [ "How to get the points of the template", "d4/dfc/tutorial-tracking-tt.html#points_tt", null ]
      ] ],
      [ "More examples", "d4/dfc/tutorial-tracking-tt.html#tracking_tt_example", null ]
    ] ],
    [ "Todo List", "dd/da0/todo.html", null ],
    [ "Deprecated List", "da/d58/deprecated.html", null ],
    [ "Bibliography", "d0/de3/citelist.html", null ],
    [ "Modules", "modules.html", "modules" ],
    [ "Classes", null, [
      [ "Class List", "annotated.html", "annotated" ],
      [ "Class Index", "classes.html", null ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", "functions_dup" ],
        [ "Functions", "functions_func.html", "functions_func" ],
        [ "Variables", "functions_vars.html", "functions_vars" ],
        [ "Enumerations", "functions_enum.html", null ],
        [ "Enumerator", "functions_eval.html", "functions_eval" ],
        [ "Related Functions", "functions_rela.html", null ]
      ] ]
    ] ],
    [ "Examples", "examples.html", "examples" ]
  ] ]
];

var NAVTREEINDEX =
[
"annotated.html",
"d0/d31/classvpSimulatorViper850.html#a2f3212655541abba2dddb01a4053eaab",
"d0/d31/classvpSimulatorViper850.html#a904507caef58091b25741a8893e31fb4",
"d0/d31/classvpSimulatorViper850.html#afae4e1f97323493701d0d56e00dd8c94",
"d0/daf/classvpScanPoint.html#a92d154ebb73586952849c46a6b3aa87c",
"d0/dfd/classvpKinect.html#aa3de6994e905029bb13aca1909f6f9e7",
"d1/d22/classvpMeSite.html#a14781b50910a5ceac9a7aa3b69836ee8",
"d1/d5f/classvpFeatureMomentBasic.html#a31cd4462707b7a3a7103ae9654bb79a8",
"d1/d9c/classvpTemplateTrackerWarpHomographySL3.html#aef44dd52317e5f982f3de51808bbfb38",
"d2/d75/classvpRobotWireFrameSimulator.html#a27bc2d678b4cd993cbf49977efa1ef1e",
"d2/d82/classvpFeatureTranslation.html#ae7748f39ff8f7435d849fc61ac8d04a8",
"d2/da2/classvpSimulatorAfma6.html#a0fd30f2cfa278adbbbf89d1cbdd2a4b8a6d42ada397e436f38d0b0c1423ce4f49",
"d2/da2/classvpSimulatorAfma6.html#a7fa74f7c6a0278f09f3e53243211ec03",
"d2/da2/classvpSimulatorAfma6.html#ae2e7078830f0e581980b3d31acac607d",
"d2/dd3/classvpSimulatorPioneer.html#aa80bd86d023bb27da0a47d548d462027",
"d3/d4e/classvpTemplateTrackerZNCCInverseCompositional.html#ac6eb92ccb19a7721b48d59899113b65e",
"d3/dc6/classvp1394TwoGrabber.html#a744d0d10809146000f6e50a40857f5efa9f9d22a23737dc2d2d257903cf0055ec",
"d3/def/classvpMeLine.html#a8beaaef5d496b75f7bfde6994249f539",
"d4/da5/classvpFeatureMomentArea.html#a1cf4769aa1f1082f9c2319e2d155db89",
"d4/dbc/classvpRowVector.html#ad22dbc9824245d38e76314a43114616c",
"d5/d48/classvpClient.html#a569b0db9c002b96ce7b48e336e246695",
"d5/d78/classvpMeNurbs.html#a52899d0c4d7ba1b5f56354457910b3ac",
"d5/db7/classvpFeaturePointPolar.html#a6758940501fc8c889bc8c2f365785784",
"d6/d60/classvpXmlParserCamera.html#a94f23c29223856c1af3b98823b3ec50aa21559ca137f9b3d08388a68702c9d440",
"d6/d74/classvpFeatureMomentAlpha.html#a6758940501fc8c889bc8c2f365785784",
"d6/d93/classvpDisplayGDI.html#a81c65dea2bec32a29b6804b5982dc1cc",
"d7/d53/servoSimuPoint2DhalfCamVelocity2_8cpp-example.html",
"d7/db4/classvpFeaturePoint.html#a3b7a0fb2b9edf668eb57f3052343d5b9",
"d8/d01/classvpHomography.html#a81de0feb8439da5179d1dd77404e2bc5",
"d8/d8c/classvpFeatureMomentCentered.html#aa66a8fefeef31b6e7e044fdf3cb0c2b1",
"d8/dca/classvpTemplateTrackerSSDInverseCompositional.html#a962282db7307d14d47119a30c53855c2",
"d8/df1/classvpMomentGenericFeature.html#a97caf26f982eacae1971f19516694152",
"d9/d57/classvpRobotBiclops.html#aa80bd86d023bb27da0a47d548d462027",
"d9/d97/classvpRobotAfma4.html#a92253427e91ef2356b8d28b261c2594a",
"d9/daa/classvpRobotViper650.html#aa3ebad1ed8704c89d84e031e23de6cdf",
"da/d17/classvpRotationMatrix.html#a29785baf4fbd27cf2f6ff0417b00e86c",
"da/d44/classvpCylinder.html#aa5e9a58657e0f07f8a8b53cc07679820",
"da/d71/classvpMbKltTracker.html#a292b8f702e6d4be1208b00f56e3481a7",
"da/da9/classvpTemplateTrackerSSDForwardAdditional.html#abf30b4bcda8008f81d0f639731068343",
"da/de3/classvpDisplayException.html#a5f2248607f62f3060ed4c37d75c67121",
"da/de9/servoAfma62DhalfCamVelocity_8cpp-example.html",
"db/d0a/classvpHomogeneousMatrix.html#a19686fd7b7d42a14be9c9e18a4ad0c5a",
"db/d5b/classvpRobotPtu46.html#aaca5d108b1cf81bad9c0e499aa7cec4b",
"db/d91/classvpMbtKltPolygon.html#a5e96eccb713236106a2b3f946c71002b",
"db/dfe/classvpDisplayD3D.html#a2fa354728c98b83e8a0ea6caa1e77984",
"dc/d09/classvpSubRowVector.html#a749883deeb83b8190a89bc503cfa38f0",
"dc/d50/classvpFeatureMomentCInvariant.html#a1a8b7542c9953046cd0a1f7337903e2d",
"dc/d82/classvpSphere.html#ade0d9394d0d5d09b5a8685c153fe7656",
"dc/dde/classvpV4l2Grabber.html#a3fabc6ec569b5aee82f904dcc2a9b706ac8562c8243c064e17f3ef127c92185b3",
"dd/d53/classvpTemplateTrackerWarpAffine.html#a9db10d39380346f679ddd91fa676de9e",
"dd/dc0/classvpTemplateTrackerZNCCForwardAdditional.html",
"dd/df8/classvpRobotAfma6.html#a0dbecb90321b9121aee6821b8c135627",
"dd/dff/tutorial-ibvs-4pts-image-tracking_8cpp-example.html",
"de/d5a/classvpForceTwistMatrix.html#adae97aac2d31dfa03297d8eef721086c",
"de/de1/classvpDisplayGTK.html#a53c8d60a4322a76eb1390f81bf5f1596",
"df/d0f/classvpDisplayWin32.html#ab1744a0a8b8a27db24c4242ec4a30154",
"df/d33/classvpRobotViper850.html#aa80bd86d023bb27da0a47d548d462027a1d987c4341b49d600f06d4e3c560a88d",
"df/d51/classvpTemplateTrackerSSD.html#a2c7dd1e2dd6a958bcd8a6755d0431b9b",
"df/de9/classvpSubMatrix.html#a93db6ca2e4db5ee59e50215c0d400309"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function hashValue()
{
  return $(location).attr('hash').substring(1).replace(/[^\w\-]/g,'');
}

function hashUrl()
{
  return '#'+hashValue();
}

function pathName()
{
  return $(location).attr('pathname').replace(/[^-A-Za-z0-9+&@#/%?=~_|!:,.;\(\)]/g, '');
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  }
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  if (node.childrenData) {
    var imgNode = document.createElement("img");
    imgNode.style.paddingLeft=(16*level).toString()+'px';
    imgNode.width  = 16;
    imgNode.height = 22;
    imgNode.border = 0;
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    var span = document.createElement("span");
    span.style.display = 'inline-block';
    span.style.width   = 16*(level+1)+'px';
    span.style.height  = '22px';
    span.innerHTML = '&#160;';
    domNode.appendChild(span);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  var ancParent = $(anchor.parent());
  if (ancParent.hasClass('memItemLeft') ||
      ancParent.hasClass('fieldname') ||
      ancParent.hasClass('fieldtype') ||
      ancParent.is(':header'))
  {
    pos = ancParent.position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath(pathName());
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = hashUrl();
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+hashValue()+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parent().attr('class')=='fieldname'){
    glowEffect(anchor.parent().parent(),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath(pathName())+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).css({'display':'block'});
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function removeToInsertLater(element) {
  var parentNode = element.parentNode;
  var nextSibling = element.nextSibling;
  parentNode.removeChild(element);
  return function() {
    if (nextSibling) {
      parentNode.insertBefore(element, nextSibling);
    } else {
      parentNode.appendChild(element);
    }
  };
}

function getNode(o, po)
{
  var insertFunction = removeToInsertLater(po.li);
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
  insertFunction();
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1].replace(/[^\w\-]/g,'');
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2(pathName())+hashUrl());
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  $(window).load(function(){
    navTo(o,toroot,hashUrl(),relpath);
    showRoot();
  });

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath(pathName())+':'+hashValue();
         a=$('.item a[class$="'+clslink.replace(/</g,'\\3c ')+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2(pathName());
       navTo(o,link,hashUrl(),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,hashUrl(),relpath);
     }
  })
}

